/**
 * check_sftp 
 * 
 * @author Alan Pipitone
 * 
 */

package check_sftp;

//import packages for generic io
import java.io.*;

//import the packages for sftp connection
import com.jcraft.jsch.*;

//import packages to check the arguments
import java.util.regex.Pattern;
import java.util.regex.Matcher;

//impor packages for random numbers
import java.util.Random;


public class Main {
    
    public static void main(String[] args) {

            
        //count the arguments
        int countHostArgument = 0;
        int countUserArgument = 0;
        int countPwdArgument = 0;
        int countHelpArgument = 0;
        int countTimeOutArgument = 0;
        int countPortArgument = 0;
        int countTempFolderArgument = 0;
        int countFtpFolderArgument = 0;
        int countWarningArgument = 0;
        int countCriticalArgument = 0;
        
        //index of arguments in the array args
        int indexHostArgument = 0;
        int indexUserArgument = 0;
        int indexPwdArgument=0;
        int indexTimeOutArgument=0;
        int indexPortArgument=0;
        int indexTempFolderArgument=0;
        int indexFtpFolderArgument = 0;
        int indexWarningArgument = 0;
        int indexCriticalArgument = 0;
        
        int port=22; //default port is 22
        int timeout=5000; //default timeout = 5 sec
        String tempFolder=""; //default folder temp is empty
        String ftpFolder="";
        //flag for valid argument (initialize to false)
        boolean validArgument=false;

        //message that will send to nagios (initialize to unknown)
        String printOut="UNKNOWN: Internal Error";
        int returnCode=3; //init returnCode to unknown

        int addArgument=0; //result of argument counters addition

        //name of text file
        String fileName="";

        //set variables for transfer time
        Long startTime_transfer;
        Long endTime_transfer;
        Long totalTime_ms;
        float totalTime_s;
        float warning;
        float critical;
        
        //try catch section
        try
        {
            //check the arguments
            for (int i=0; i<args.length; i++)
            {
                //arguments option
                Pattern pHost = Pattern.compile("-host=");
                Pattern pUser = Pattern.compile("-user=");
                Pattern pPwd = Pattern.compile("-pwd=");
                Pattern pHelp = Pattern.compile("-help");
                Pattern pTimeOut = Pattern.compile("-t=");
                Pattern pPort = Pattern.compile("-port=");
                Pattern pTemp = Pattern.compile("-temp=");
                Pattern pFtpFolder = Pattern.compile("-ftpfolder=");
                Pattern pWarning = Pattern.compile("-warning=");
                Pattern pCritical = Pattern.compile("-critical=");
                                         
                //get the matcher objects
                Matcher mHost = pHost.matcher(args[i]);
                Matcher mUser = pUser.matcher(args[i]);
                Matcher mPwd = pPwd.matcher(args[i]);
                Matcher mHelp = pHelp.matcher(args[i]);
                Matcher mTimeOut = pTimeOut.matcher(args[i]);
                Matcher mPort = pPort.matcher(args[i]);
                Matcher mTemp = pTemp.matcher(args[i]);
                Matcher mFtpFolder = pFtpFolder.matcher(args[i]);
                Matcher mWarning = pWarning.matcher(args[i]);
                Matcher mCritical = pCritical.matcher(args[i]);

                //looking for -host argument
                while(mHost.find())
                {
                    countHostArgument++;
                    indexHostArgument=i;
                }

                //looking for -user argument
                while(mUser.find())
                {
                    countUserArgument++;
                    indexUserArgument=i;
                }

                //looking for -pwd argument
                while(mPwd.find()) 
                {
                    countPwdArgument++;
                    indexPwdArgument=i;
                }

                //looking for -help argument
                while(mHelp.find())
                {
                    countHelpArgument++;
                }

                //looking for -t argument
                while(mTimeOut.find())
                {
                    countTimeOutArgument++;
                    indexTimeOutArgument=i;
                }

                //looking for -port argument
                while(mPort.find())
                {
                    countPortArgument++;
                    indexPortArgument=i;
                }

                //looking for -temp argument
                while(mTemp.find())
                {
                    countTempFolderArgument++;
                    indexTempFolderArgument=i;
                }
                
               //looking for -ftpfolder argument
                while(mFtpFolder.find())
                {
                    countFtpFolderArgument++;
                    indexFtpFolderArgument=i;
                }
                
                //looking for -warning argument
                while(mWarning.find())
                {
                    countWarningArgument++;
                    indexWarningArgument=i;
                }
                
                //looking for -critical argument
                while(mCritical.find())
                {
                    countCriticalArgument++;
                    indexCriticalArgument=i;
                }
            }

            //add the counters arguments
            addArgument= countHostArgument + countPwdArgument + countPwdArgument + countTimeOutArgument + countPortArgument + countTempFolderArgument + countFtpFolderArgument + countWarningArgument + countCriticalArgument;

            //if all arguments are correctly set then the script opens the connection
            if(args.length == addArgument & countHostArgument == 1 & countPwdArgument == 1 & countPwdArgument == 1 & countWarningArgument == 1 & countCriticalArgument == 1 & (countTimeOutArgument==1 | countTimeOutArgument==0) & (countPortArgument==1 | countPortArgument==0) & (countTempFolderArgument==1 | countTempFolderArgument==0) & (countFtpFolderArgument==1 | countFtpFolderArgument==0) & countHelpArgument==0)
            {

                //check if port is set
                if(countPortArgument==1)
                {
                    //convert argument from string to integer
                    port = Integer.parseInt( args[indexPortArgument].replace("-port=","") );
                }

                //check if timeout is set
                if(countTimeOutArgument==1)
                {
                    //convert argument from string to integer
                    timeout = (Integer.parseInt( args[indexTimeOutArgument].replace("-t=","") ))*1000;
                }

                //check if temp folder is set
                if(countTempFolderArgument==1)
                {
                    //set the folder
                    tempFolder = args[indexTempFolderArgument].replace("-temp=","");
                }
                
                //check if ftp folder is set
                if(countFtpFolderArgument==1)
                {
                    //set the ftp folder
                    ftpFolder = args[indexFtpFolderArgument].replace("-ftpfolder=","");
                }

                //generate random number
                Random generator = new Random();
                int randomIndex1 = generator.nextInt( 5000 );

                String randomSTR1 = Integer.toString(randomIndex1);

                //create the file name
                fileName = tempFolder + "SFTPtestFile_tmpCode_" + randomSTR1 + ".txt";

                //if filename already exist, confirmFileName will return new name
                fileName = confirmFileName(fileName,generator,tempFolder);

                File file = new File(fileName);

                //create the file
                file.createNewFile();

                //write into text file
                Writer out = new OutputStreamWriter(new FileOutputStream(fileName));

                out.write("Transfer test from Nagios Server");

                //close the file
                out.close();

                String hostName = args[indexHostArgument].replace("-host=","");
                String userName = args[indexUserArgument].replace("-user=","");
                String userPwd = args[indexPwdArgument].replace("-pwd=","");

                //create the Jsch object
                JSch jsch = new JSch();

                //create the remote session with username, host and port
                Session session = jsch.getSession(userName, hostName, port);

                java.util.Properties config = new java.util.Properties();
                //don't ask for the key checking but add it automatically
                config.put("StrictHostKeyChecking", "no");
                //Preferred Authentication is with Password
		config.put("PreferredAuthentications", "password");
                session.setConfig(config);

                //set the password for object SftpUserInfo
                session.setPassword(userPwd);
                
                //start time counter
                startTime_transfer = System.currentTimeMillis();
                
                //connect to host with port, username and password previously set
                session.connect(timeout);

                //open the sftp channel
                ChannelSftp channel = (ChannelSftp) session.openChannel("sftp");

                channel.connect(timeout);

                //change directory if it is set
                if(!(ftpFolder.equals("")))
                {
                    channel.cd(ftpFolder);
                }

                                
                //put this program on the folder
                channel.put(fileName, fileName.replace(tempFolder,""));

                //disconnect from sftp server
                channel.disconnect();
                session.disconnect();

                //End time counter
                endTime_transfer = System.currentTimeMillis();
                
                //calculate total Time
                totalTime_ms = (endTime_transfer - startTime_transfer);
                totalTime_s = totalTime_ms.floatValue()/1000;
                
                //reconnect to the server (if you don't do this, some sftp server doesn't allow you to delete file)
                session = jsch.getSession(userName, hostName, port);
                //set the password
                session.setPassword(userPwd);
                
                //open the session
                session.connect(timeout);

                //open sftp channel
                channel = (ChannelSftp) session.openChannel("sftp");
                channel.connect(timeout);

                //change directory if it is set
                if(!(ftpFolder.equals("")))
                {
                    channel.cd(ftpFolder);
                }
                                
                //remove the test file
                channel.rm(fileName.replace(tempFolder,""));
         
                channel.disconnect();
                session.disconnect();
                
                file.delete();

                //set the critical value
                critical = new Float(args[indexCriticalArgument].replace("-critical=",""));
                //set the warning value
                warning = new Float(args[indexWarningArgument].replace("-warning=",""));
                
                if(totalTime_ms >= critical)
                {
                    printOut="CRITICAL: transfer time to " + hostName + " is " + totalTime_s + "s|time=" + totalTime_s + "s;" + warning/1000 + ";" + critical/1000 + ";;";

                    //return exit code 2 (critical)
                    returnCode = 2;
                }
                else if(totalTime_ms >= warning)
                {
                    printOut="WARNING: transfer time to " + hostName + " is " + totalTime_s + "s|time=" + totalTime_s + "s;" + warning/1000 + ";" + critical/1000 + ";;";

                    //return exit code 1 (warning)
                    returnCode = 1;
                }
                else
                {
                    printOut="OK: transfer time to " + hostName + " is " + totalTime_s + "s|time=" + totalTime_s + "s;" + warning/1000 + ";" + critical/1000 + ";;";

                    //return exit code 0 (ok)
                    returnCode = 0;
                }
                
                //all arguments are correctly set
                validArgument=true;

            }

            //argument is correctly set for print help
            if(countHelpArgument == 1 & args.length==1)
            {
                printOut = printHelp(true); //print help
                returnCode = 3; //return unknown code for nagios
                validArgument = true;
            }

            //if arguments are not valid print "invalid argument" + the help
            if (validArgument == false)
            {
                printOut = printHelp(false);  //print help with "Invalid Argument"
                returnCode = 3;  //return unknown code for nagios
            }
 
            //return message and relative exit code
            System.out.println(printOut);
            System.exit(returnCode);

        }
         catch (JSchException e)
        {
            //delete the text file if exist
            File file = new File(fileName);
            file.delete();

            //return critical message and relative exit code
            System.out.println("CRITICAL: " + e.getLocalizedMessage() + "|time=s;;;;");
            System.exit(2);
        }
        catch (Exception e)
        {
            //delete the text file if exist
            File file = new File(fileName);
            file.delete();

            //return critical message and relative exit code
            System.out.println("CRITICAL: " + e.getLocalizedMessage() + "|time=s;;;;");
            System.exit(2);
        }
    }

    //if filename already exist, the following function will return new name
    public static String confirmFileName(String fileNameArg, Random randomGen, String folderTmp){
        
        String filename=fileNameArg;
             
        File file = new File(fileNameArg);

        while(file.exists())
        {
            //generate random number
            //Random generator = new Random();
            int randomIndex1 = randomGen.nextInt( 5000 );

            String randomSTR1 = Integer.toString(randomIndex1);

            //create the new file name
            filename =folderTmp + "SFTPtestFile_tmpCode_" + randomSTR1 + ".txt";

            file = new File(filename);
        }

        return filename;

    }

    //print the help
    public static String printHelp(boolean validArgs){
            String returnString = "\n\n";
            returnString = returnString + "HELP:";
            returnString = returnString + "\n\n";
            returnString = returnString + "This plug-in (author: Alan Pipitone) allows Nagios to check sftp connections.";
            returnString = returnString + "\n\n";
            returnString = returnString + "How it works:";
            returnString = returnString + "\n\n";
            returnString = returnString + "This plug-in creates a text file, with random name, in the temp folder of the";
            returnString = returnString + "\n";
            returnString = returnString + "Nagios server (you can choose which folder), then it opens the sftp connection with the remote";
            returnString = returnString + "\n";
            returnString = returnString + "server that you want to check, transfers the text file from the Nagios server to the sftp server";
            returnString = returnString + "\n";
            returnString = returnString + "and finally it deletes the text file from the sftp server and from the local server.";
            returnString = returnString + "\n";
            returnString = returnString + "If everything goes well the plug-in will return a message ok, otherwise it will return a message";
            returnString = returnString + "\n";
            returnString = returnString + "critical. It even returns the performance data.";
            returnString = returnString + "\n\n";
            returnString = returnString + "The plug-in works with java 1.7 or higher.";
            returnString = returnString + "\n\n";
            returnString = returnString + "Usage:   java -jar check_sftp.jar [-host=<hostname> -user=<username> -pwd=<password>";
            returnString = returnString + "\n";
            returnString = returnString + "                                   -warning=<warning> -critical=<critical>]";
            returnString = returnString + "\n";
            returnString = returnString + "                                  [-port=<port number>] [-t=<time out>] [-temp=<temp folder>]";
            returnString = returnString + "\n";
            returnString = returnString + "                                  [-ftpfolder=<folder>]";
            returnString = returnString + "\n";
            returnString = returnString + "                                  [-help]";
            returnString = returnString + "\n\n";
            returnString = returnString + "Arguments:";
            returnString = returnString + "\n\n";
            returnString = returnString + "   -host=<host name>:     Host name to contact. Mandatory argument.";
            returnString = returnString + "\n\n";
            returnString = returnString + "   -user=<user name>:     User name for connection. Mandatory argument.";
            returnString = returnString + "\n\n";
            returnString = returnString + "   -pwd=<password>:       Password for connection. Mandatory argument.";
            returnString = returnString + "\n\n";
            returnString = returnString + "   -warning=<warning>:    Warning value for transfer timing (in milliseconds).";
            returnString = returnString + "\n";
            returnString = returnString + "                          Mandatory argument.";
            returnString = returnString + "\n\n";
            returnString = returnString + "   -critical=<critical>:  Critical value for transfer timing (in milliseconds).";
            returnString = returnString + "\n";
            returnString = returnString + "                          Mandatory argument.";
            returnString = returnString + "\n\n";
            returnString = returnString + "   -t=<time out>:         Timeout (in seconds) for connection. Optional argument.";
            returnString = returnString + "\n";
            returnString = returnString + "                          Default timeout is 5 seconds.";
            returnString = returnString + "\n\n";
            returnString = returnString + "   -port=<port number>:   Port number for the sftp connection. Optional argument.";
            returnString = returnString + "\n";
            returnString = returnString + "                          Default port is 22.";
            returnString = returnString + "\n\n";
            returnString = returnString + "   -temp=<temp folder>:   Temp folder that will contain the text file to transfer.";
            returnString = returnString + "\n";
            returnString = returnString + "                          Optional argument.";
            returnString = returnString + "\n";
            returnString = returnString + "                          Default temp is the working folder of the script.";
            returnString = returnString + "\n\n";
            returnString = returnString + "   -ftpfolder=<folder>:   The remote sftp folder where you want to put the file.";
            returnString = returnString + "\n";
            returnString = returnString + "                          Optional argument.";
            returnString = returnString + "\n";
            returnString = returnString + "                          Default folder is the home sftp folder.";
            returnString = returnString + "\n\n";
            returnString = returnString + "   -help:                 Show the help. Use this argument alone. Optional argument.";
            returnString = returnString + "\n";
            returnString = returnString + "                          Don't use it with nagios.";
            returnString = returnString + "\n\n";
            returnString = returnString + "Examples:";
            returnString = returnString + "\n\n";
            returnString = returnString + "java -jar check_sftp.jar -host=server1 -user=admin -pwd=Password01 -ftpfolder=nagios_test -warning=800 -critical=2000";
            returnString = returnString + "\n";
            returnString = returnString + "to change the remote sftp directory (nagios_test in this case)";
            returnString = returnString + "\n\n";
            returnString = returnString + "java -jar check_sftp.jar -host=server1 -user=admin -pwd=Password01 -ftpfolder=test/nagios_test -warning=800 -critical=2000";
            returnString = returnString + "\n";
            returnString = returnString + "to change the remote sftp directory (test/nagios_test in this case)";
            returnString = returnString + "\n\n";
            returnString = returnString + "java -jar check_sftp.jar -host=server1 -user=admin -pwd=Password01 -temp=/var/TempNagios/ -warning=800 -critical=2000, for the temp";
            returnString = returnString + "\n";
            returnString = returnString + "folder that will contain the text file to transfer (remember the final character \"/\" )";
            returnString = returnString + "\n\n";
            returnString = returnString + "java -jar check_sftp.jar -help , to print the help.";
            returnString = returnString + "\n\n";
            returnString = returnString + "Of course you can put all optional argument together (except -help), the ordering of ";
            returnString = returnString + "\n";
            returnString = returnString + "the arguments doesn't matter:";
            returnString = returnString + "\n\n";
            returnString = returnString + "java -jar check_sftp.jar -host=server1 -user=admin -pwd=Password01 -t=10 -port=23 -temp=/var/TempNagios/";


            if (validArgs == false) //if arguments are not valid
            {

                returnString = "\n\nInvalid arguments." + returnString; //add "Invalid argument" to help
            }

            return returnString;
    }

}
